#!/usr/bin/perl

use warnings;
use strict;
use YAML;

opendir CURDIR, '.' or die "Cannot open current dir: $!\n";
my @filenames = sort grep {/\.gif$/} readdir CURDIR;
my @codes;
my $codesfile = '_define.ini';

open CODES, $codesfile or die "Cannot open $codesfile: $!";
@codes = <CODES>;
die "codes and filenames mismatch!\n" if @codes != @filenames;
close CODES;
my @smilies; # AoH [ {code => $code, filename =>  $filename} ....]
my %filenames; 
my %codes;
for my $i (0..$#codes) {
    push @smilies, {code => $codes[$i], filename => $filenames[$i]};
    foreach (split /,/, $codes[$i]) {
        s/\s+$//;
        $codes{$_} = $i;
    }
    $filenames{$filenames[$i]} = $i;
}

my @bad = qw{
*sex* *narkoman* *crazy_girl* *bos* *oxotnik* *elf* *angry_fuck* 
*lol2* *FUCK* *alkoholik* *poveshen* *haha* 
*haha_lol* *girl_haha* *idi_nak*
};

my @badids = sort {$b <=> $a} map {$codes{$_}} @bad;

foreach my $id (@badids) {
    unlink $smilies[$id]{filename};
    delete $smilies[$id];
}

open CODES, ">$codesfile";
print CODES $_->{code} foreach @smilies;
